class CrawCannon extends Goon{
  int  shotRate=10;
  int shields=8;
  boolean started=false;
  boolean blocking=false;

  ArrayList bullets=new ArrayList();
  CrawCannon(Vector3D p){
    pos=new Vector3D(100,height/2);
    vel=new Vector3D();

    rad=80;

  }
  void unique(){
    blocking=false;
    if(!started){
      for(int j=0;j<shields;j++){
        Shield s=new Shield(pos,j,shields,this); 
        monsters.add(s);

      }
      started=true;
    }
    Vector3D looking=h.pos.copy();
    looking.sub(pos);
    angle=looking.heading2D();

    if(frameCount%shotRate==0){
      shootBullets();
    }
    for(int i=0; i<bullets.size();i++){
      LaserBall l=(LaserBall)bullets.get(i);
      l.update();

    }

  }


  void movement(){
    pos.add(vel);
  }
  void shootBullets(){
    for(int i=0;i<1;i++){
      LaserBall l=new LaserBall(pos,angle,random(0,PI), bullets);
      bullets.add(l);

    }
  }
  void checkCollision(){
    if(shields>0){
      WingMan w= h.leftWingMan;
      for(int t=0;t<2;t++){
        Vector3D v = w.pos.copy();
        v.sub(pos);
        if(v.magnitudeSquared2D()<6400){
          v.mult(.9);
          w.vel.add(v); 
          blocking=true;
        }
        w=h.rightWingMan;
      } 
    }
    else{
      super.checkCollision();
      if(!alive){
        for(int i=0; i< bullets.size(); i++){
         LaserBall g=(LaserBall)bullets.get(i);
         monsters.add(g); 
        }
      }
    }
  }
  void render(){
    pushMatrix();
    noStroke();

    translate(pos.x,pos.y);
    noFill();

    for(int i=0; i<shields; i++){
      stroke(200-20*i);
      if(blocking){
        stroke(200,250,250); 
      }
      ellipse(0,0,160-6*i,160-6*i);
    }
    noStroke();
    rotate(angle);
    fill(255);
    ellipse(0,0,rad,rad);
    fill(0,250,110);
    beginShape();
    vertex(0,rad/2);
    vertex(0,-rad/2);
    vertex(rad/2,0);
    endShape();
    fill(200,250,250);
    beginShape();
    vertex(rad/3,0);
    vertex(0,rad/3);
    vertex(rad/8,0);
    vertex(0,-rad/3);
    endShape();


    popMatrix();
  }
}


class Shield extends Goon{   /////////////////////////////////   Shield             //////////////////////////////////////////////////////////////
  int orbitDist=80;
  float orbitSpeed=.03;//rad/frame
  CrawCannon parent;
  Vector3D orbitPoint;
  float offsetAngle;
  Shield(Vector3D p, int index,int maxShields,CrawCannon par){
    orbitPoint= p.copy();
    parent=par;
    angle=TWO_PI*index/maxShields;
    offsetAngle=angle;
    pos=new Vector3D();
    pos.x=orbitPoint.x+orbitDist*cos(angle);
    pos.y=orbitPoint.y+orbitDist*sin(angle);
    vel=new Vector3D();
    acc=new Vector3D();
    rad=30;
    type = SHIELD;

  }
  void isOnLine(Vector3D v1, Vector3D v2){
    if(checkAlongLine(v1,v2,v1.distance(v1,v2))){
      monsters.remove(this);
      parent.shields--;

    }
  }
  void checkCollision(){
    //

  }
  boolean checkAlongLine(Vector3D p1,Vector3D p2,float distance){

    Vector3D pm = p1.copy();
    pm.add(p2);
    pm.mult(.5);
    if(pm.distanceSquared2D(pm,pos)<rad*rad){
      return true;
    }

    if(distance>5){
      return(checkAlongLine(p1,pm,distance/2)||checkAlongLine(pm,p2,distance/2));//recursion w00t!

    }
    return false;
  }
  void unique(){
    angle=-parent.angle*2+offsetAngle;

    pos.x=orbitPoint.x+orbitDist*cos(angle);
    pos.y=orbitPoint.y+orbitDist*sin(angle);
  }
  void checkWalls(){
  }
  void movement(){
    pos.add(vel);
  }
  void render(){
    pushMatrix();
    noStroke();
    translate(pos.x,pos.y);
    rotate(angle);
    fill(150);
    if(parent.blocking){
      fill(200,250,250);
    }
    ellipse(0,0,rad*1.3,rad*1.3);
    rotate(-4*angle);
    fill(0,250,80);
    if(parent.blocking){
      fill(100,255,255);
    }
    ellipse(rad/3,0,rad/4,rad/4);
    ellipse(-rad/3,0,rad/4,rad/4);
    ellipse(0,-rad/3,rad/4,rad/4);
    ellipse(0,rad/3,rad/4,rad/4);
    popMatrix();
  }
}

class LaserBall extends Goon{   /////////////////////////////////   LaserBall             //////////////////////////////////////////////////////////////
  float speed=6;
  float spin=.01;
  boolean oneShot=false;
  ArrayList parent;
  LaserBall(Vector3D p){
    pos= p.copy();
    acc=new Vector3D();
    vel=new Vector3D(speed,random(0,TWO_PI),true);
    rad=25;
    type = LASERBALL;
    if(random(0,1)<.5){
      spin*=-1;
    }
  }
  LaserBall(Vector3D p,float moveAngle, float startAngle, ArrayList par){
    parent=par;
    pos= p.copy();
    acc=new Vector3D();
    vel=new Vector3D(speed,moveAngle,true);
    angle=startAngle;
    rad=25;
    type = LASERBALL;
    oneShot=true;
  }

  void checkWalls(){
    if(oneShot){
      if(pos.x<-20||pos.x>width+20||pos.y<-20||pos.y>height+20){
      parent.remove(this);
      monsters.remove(this);
    }
    }
    else{
    if(pos.x<0){
      vel.x=abs(vel.x); 
    } 
    if(pos.x>width){
      vel.x=-abs(vel.x); 
    } 
    if(pos.y<0){
      vel.y=abs(vel.y); 

    } 
    if(pos.y>height){
      vel.y=-abs(vel.y); 
    }
  }
  }


  void movement(){
    vel.add(acc);
    pos.add(vel);
    angle+=spin;
  }

  void unique(){
    line(pos.x+vel.x,pos.y+vel.y,pos.x-2000*sin(angle),pos.y+2000*cos(angle));
    noStroke();
    Vector3D ptOut = new Vector3D(pos.x-2000*sin(angle),pos.y+2000*cos(angle));
    // checkAlongLine(pos,ptOut,pos.distance(pos,ptOut));
    for(int i=0;i<monsters.size();i++){
      Goon g = (Goon)monsters.get(i);
      if(g.type()==SHIELD){
        isOnLine(pos,ptOut);
      }
    }
  }
  void checkCollision(){
    if(h.hitWingMan(pos,rad)){
      if(oneShot){
        parent.remove(this);
        monsters.remove(this);
      }
      else{
        monsters.remove(this);
      }
      stroke(110,150,200);
      line(pos.x,pos.y,pos.x-2000*sin(angle),pos.y+2000*cos(angle));
      noStroke();
      Vector3D ptOut = new Vector3D(pos.x-2000*sin(angle),pos.y+2000*cos(angle));
      checkAlongLine(pos,ptOut,pos.distance(pos,ptOut));
      for(int i=0;i<monsters.size();i++){
        Goon g = (Goon)monsters.get(i);
        if(g.type()==SHIELD){
          g.isOnLine(pos,ptOut);

        }
        alive = false;
      }
    }
  }
  void checkAlongLine(Vector3D p1,Vector3D p2,float distance){

    Vector3D pm = p1.copy();
    pm.add(p2);
    pm.mult(.5);
    h.hitWingMan(pm,0);

    if(distance>5){
      checkAlongLine(p1,pm,distance/2);///recursion w00t!
      checkAlongLine(pm,p2,distance/2);
    }
  }


  void render(){
    pushMatrix();
    noStroke();

    translate(pos.x,pos.y);
    rotate(angle);
    fill(0,250,190);
    ellipse(0,0,rad*1.3,rad*1.3);
    fill(0,250,110);
    beginShape();
    vertex(-rad/2,0);
    vertex(rad/2,0);
    vertex(0,rad/2);
    endShape();
    fill(200,250,250);

    beginShape();
    vertex(-rad/4,0);
    vertex(0,2);
    vertex(rad/4,0);
    vertex(0,rad/2-3);
    endShape();
    stroke(255);
    line(0,0,0,rad/2*1.3);
    noStroke();


    popMatrix();
  }

}
